/////////////////////////////////////////////////////////////////////////////
/*
  Env_sense.c

  Uses Sesirion module for temp/humodity.
  December 3, 2013
*/
#include "simpletools.h"
#include "sht11.h"
#include "simpletext.h"
#include "fdserial.h"

serial *xbee;

static volatile float sht11_temp;  // Access to sht11 cog
static volatile float sht11_humid;   // Access to sht11 cog

unsigned int sht11stack[40 + 25];  // For sht11 cog

void sht11(void* par);
int XB_remote(void);
void menu(void);
/////////////////////////////////////////////////////////////////////////////
int main()
{
 // Add startup code here.
/* Start up the cog */
  cogstart(&sht11, NULL, sht11stack, sizeof(sht11stack));

/*                     Rx  Tx mode BAUD  */
  xbee = fdserial_open(11, 10, 0, 9600);
  pause(50);

  int xbcmd = -1;

  menu();
  writeStr(xbee,"> ");
 
  while(1)
  {
    // Add main loop code here.
    xbcmd = XB_remote();
  }  
}

void menu()
{
  writeStr(xbee,"Menu - help, onled, offled, temp, humid, \n");
}

/////////////////////////////////////////////////////////////////////////////
/* XBee IO function. */
int XB_remote()
{
  char inBuff[40];
  char outBuff[10];
  int retval = 0;
  
  
  if(fdserial_rxReady(xbee))
  {
    readStr(xbee, inBuff, 40);
    //writeStr(xbee,"> ");
    if(!strcmp(inBuff, "onled")) high(26);
    else if(!strcmp(inBuff,"offled")) low(26);
    else if(!strcmp(inBuff,"temp"))
    {
      sprint(outBuff,"%f",sht11_temp);
      writeStr(xbee,outBuff);
      writeStr(xbee,"\n");
    }
    else if(!strcmp(inBuff,"humid"))
    {
      sprint(outBuff,"%f",sht11_humid);
      writeStr(xbee,outBuff);
      writeStr(xbee,"\n");
    }
    else if(!strcmp(inBuff,"help")) menu();
    else
    {
      writeLine(xbee,"Invalid Command!");
      retval = -1;
    }
    writeStr(xbee,"> ");  
  }
  return retval;
}

/////////////////////////////////////////////////////////////////////////////
/* cog function */
void sht11(void* par)
{
  sht11_pins(9, 8);

  while(1)
  {
/* Raw temp */
    //int soT = sht11_tempRaw();
    //print("soT=%d", soT);
/* Raw real humidity */
    int soRH = sht11_rhRaw();
    //print("soRH=%d", soRH);
/* Degrees C */
    //float sTC = sht11_degC();
    //print(" sTC=%f",sTC);
/* Degrees F */
    float sTf = sht11_degF();
    sht11_temp = sTf;
    //print("sTf=%f", sTf);
/* Raw humidity Linear */
    float sRHL = sht11_rhLinear();
    //print(" sRHL=%f", sRHL);
/* Raw humidity True */
    float sRHT = sht11_rhTrue();
    sht11_humid = sRHT;
    //print(" sRHT=%f\n", sRHT);
/* Dew point C */
    //float sDPC = sht11_dewPointC(); 
    //print(" sDPC=%f\n", sDPC);
    pause(250);
  }
}
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
